/*
 * GetFileManifest.java
 *
 * Created on May 29, 2007, 9:00 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.io.*;
import javax.swing.JFileChooser;
import javax.swing.JPanel;

/**
 *
 * @author Fid
 */
public class GetFileManifest extends JPanel {
    
    /**
     * Creates a new instance of GetFileManifest
     */
    public GetFileManifest() {

        try {
            //Create a file chooser
            JFileChooser fc = new JFileChooser();
            fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            fc.setMultiSelectionEnabled(false);
            int result = fc.showOpenDialog(this);

            if (result == JFileChooser.APPROVE_OPTION) {
                File dir = fc.getSelectedFile();

                BufferedWriter manifest = new BufferedWriter(new FileWriter(dir.getAbsolutePath() + "\\manifest.txt"));

                writeManifest(dir, manifest, "");

                manifest.close();

            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        GetFileManifest m = new GetFileManifest();
    }
    
    // recursively traverse the tree and write manifest
    static void writeManifest(File dir, BufferedWriter manifest, String path) throws IOException {

        File[] files = dir.listFiles();
        path = path.concat(dir.getName()+"\\"); // cumulative path, relative to starting directory
        
        if (files == null) {
            // Either dir does not exist or is not a directory
            System.out.println("Empty file list for " + dir.getAbsolutePath());
        } else {
            for (int i = 0; i < files.length; i++) {

                File file = files[i];

                if (file.isDirectory()) {
                    writeManifest(file, manifest, path);
                } else {
                    String entry = path + file.getName();
                    manifest.write(entry);
                    manifest.newLine();
                    System.out.println(entry);
                }

            }
        }

    }


}
